/* EPITA - IP - S3/4 */
/* question03 */

#define QNUM 3
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question03.h"

static
void random_fill(int *begin, int *end) {
  for (; begin < end; begin++)
    *begin = random() % 10;
}

static
void lin_fill(int *begin, int *end) {
  for (int i = 1; begin < end; i++, begin++)
    *begin = i;
}

static
void print_array(int *begin, int *end) {
  for (; begin < end; begin++) {
    printf("| %2d ", *begin);
  }
  printf("|\n");
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  int *tab = malloc(len * sizeof (int));
  lin_fill(tab, tab + len);
  printf("  array:\n    ");
  print_array(tab, tab + len);
  printf("  array_count_occurences(begin, end, %d): ", (int)(len / 2));
  printf("%zu\n", array_count_occurences(tab, tab + len, (int)(len / 2)));
  free(tab);
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  int *tab = malloc(len * sizeof (int));
  random_fill(tab, tab + len);
  printf("  array:\n    ");
  print_array(tab, tab + len);
  size_t pos = random() % len;
  printf("  array_count_occurences(begin, end, %d): ", tab[pos]);
  printf("%zu\n", array_count_occurences(tab, tab + len, tab[pos]));
  int val = random() % 10;
  printf("  array_count_occurences(begin, end, %d): ", val);
  printf("%zu\n", array_count_occurences(tab, tab + len, val));
  val = 42;
  printf("  array_count_occurences(begin, end, %d): ", val);
  printf("%zu\n", array_count_occurences(tab, tab + len, val));

  free(tab);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
