/* EPITA - IP - S3/4 */
/* question09 */

#define QNUM 9
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question09.h"

static
struct list* build_list(size_t len, struct list store[]) {
  struct list *cur;
  for (cur = store; len > 0; len--) {
    cur->value = random() % 256;
    cur->next = cur + 1;
    cur += 1;
  }
  cur->next = NULL;
  return store;
}

static
void print_list(struct list *list, const char *prefix) {
  int line, base;
  base = line = printf("%s =", prefix);
  if (list->next == NULL) {
    printf(" EMPTY\n");
    return;
  }
  for (struct list *cur = list; cur->next; cur = cur->next) {
    if (line > 72) {
      printf("\n%*s", base, "");
      line = base;
    }
    line += printf(" -> %3d", cur->next->value);
  }
  printf("\n");
}

static
void print_hist(size_t hist[256]) {
  size_t count = 0;
  for (size_t i = 0; i < 256 / 4; i++) {
    printf("|");
    for (size_t j = 0; j < 4; j++) {
      if (hist[i + 64 * j]) {
	printf("hist[%3zu]:%2zu|", i + 64 * j, hist[i + 64 * j]);
	count += hist[i + 64 * j];
      } else {
	printf("hist[%3zu]:  |", i + 64 * j);
      }
    }
    printf("\n");
  }
  printf("summary count: %zu\n", count);
}

static
void fixed_test(size_t len) {
  printf("Random tests:\n");
  struct list *store, *list;
  store = calloc(len + 2, sizeof (struct list));
  list = build_list(len, store);
  if (len < 100)
    print_list(list, "list");
  size_t hist[256];
  for (size_t *cur = hist; cur < hist + 256; cur++)
    *cur = random();
  size_t outlen = list_hist(list, hist);
  print_hist(hist);
  printf("output len: %zu\n", outlen);
  free(store);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
    }
  exit(0);
}
