/* EPITA - IP - S3/4 */
/* question16 */

#define QNUM 16
#define QOPT "filename"
#define QNOPT 1

# include <assert.h>
# include <err.h>
# include <fcntl.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question16.h"

static
int is_stdin(const char *fname) {
  const char *minus = "-";
  size_t i;
  for (i = 0; fname[i] && fname[i] == minus[i]; i++) {}
  return fname[i] == minus[i];
}

int main(int argc,char *argv[])
{
  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      const char *fname = argv[1];
      int use_stdin = is_stdin(fname);
      int fd;

      if (use_stdin) {
	fd = STDIN_FILENO;
      } else {
	if ( (fd = open(fname, O_RDONLY)) == -1)
	  err(3, "can't open %s", fname);
      }
      size_t count = newline_counter(fd);
      printf("newline count: %zu\n", count);
      if (!use_stdin)
	close(fd);
    }
  exit(0);
}
